(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file defines the database schema.                                                                              //
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         //
// query it makes, so you can see if it's doing queries too often, etc.                                                //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      //
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            //
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              //
// The users collection is special and can be accessed through `Meteor.users`.                                         //
// See https://docs.meteor.com/#/full/meteor_users.                                                                    //
//                                                                                                                     //
// There are two distinct types of entries in the users collection: identities and accounts. An                        //
// identity contains personal profile information and typically includes some intrinsic method for                     //
// authenticating as the owner of that information.                                                                    //
//                                                                                                                     //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           //
// Each account can have multiple identities linked to it. To log in as an account you must first                      //
// authenticate as one of its linked identities.                                                                       //
//                                                                                                                     //
// Every user contains the following fields:                                                                           //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         //
//        stable SHA-256 ID of this identity, hex-encoded.                                                             //
//   createdAt: Date when this entry was added to the collection.                                                      //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                //
//   services: Object containing login data used by Meteor authentication services.                                    //
//   expires: Date when this user should be deleted. Only present for demo users.                                      //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   //
//                     rather than as a Date object. We should fix that.                                               //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     //
//              link. This field contains the app ID of the app that the user started out demoing.                     //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      //
//              being a demo user.                                                                                     //
//                                                                                                                     //
// Identity users additionally contain the following fields:                                                           //
//   profile: Object containing the data that will be shared with users and grains that come into                      //
//            contact with this identity. Includes the following fields:                                               //
//       service: String containing the name of this identity's authentication method.                                 //
//       name: String containing the chosen display name of the identity.                                              //
//       handle: String containing the identity's preferred handle.                                                    //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          //
//                an identicon will be used.                                                                           //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          //
//   referredBy: ID of the Account that referred this Identity.                                                        //
//                                                                                                                     //
// Account users additionally contain the following fields:                                                            //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      //
//                       a separate array here so that we can use a Mongo index to enforce the                         //
//                       invariant that an identity only be a login identity for a single account.                     //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        //
//                 to do this checking automatically.                                                                  //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  //
//   signupKey: If this is an invited user, then this field contains their signup key.                                 //
//   signupNote: If the user was invited through a link, then this field contains the note that the                    //
//               inviter admin attached to the key.                                                                    //
//   signupEmail: If the user was invited by email, then this field contains the email address that                    //
//                the invite was sent to.                                                                              //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    //
//                       terms of service.                                                                             //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       //
//              module writes data here; we merely read it. Missing fields should be treated as                        //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           //
//              TODO(cleanup): Use for referral bonus too.                                                             //
//   storageUsage: Number of bytes this user is currently storing.                                                     //
//   payments: Object defined by payments module, if loaded.                                                           //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 //
//   accessRequests: Object containing the following fields; used to limit spam.                                       //
//       count: Number of "request access" emails during sent during the current interval.                             //
//       resetOn: Date when the count should be reset.                                                                 //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              //
//                        stop writing new referredBy values onto Identities for this account.                         //
//   referredCompleteDate: The Date at which the completed referral occurred.                                          //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        //
//                        reliably determining which Identity's names are safe to display.                             //
//   experiments: Object where each field is an experiment that the user is in, and each value                         //
//           is the parameters for that experiment. Typically, the value simply names which                            //
//           experiment group which the user is in, where "control" is one group. If an experiment                     //
//           is not listed, then the user should not be considered at all for the purpose of that                      //
//           experiment. Each experiment may define a point in time where users not already in the                     //
//           experiment may be added to it and assigned to a group (for example, at user creation                      //
//           time). Current experiments:                                                                               //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       //
//               test group will see a plan selection dialog and asked to make an explitic choice                      //
//               (possibly "free") before they can create grains (but not when opening someone                         //
//               else's shared grain). The goal of the experiment is to determine whether this                         //
//               prompt scares users away -- and also whether it increases paid signups.                               //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              //
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 126
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 127
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 128
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 129
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 130
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 131
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 132
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 135
                                                                                                                       //
Packages = new Mongo.Collection("packages");                                                                           // 137
// Packages which are installed or downloading.                                                                        //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                //
//       >1 = download byte count.                                                                                     //
//   error:  If status is "failed", error message string.                                                              //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          //
//   appId:  If status is "ready", the application ID string.  Packages representing different                         //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         //
//       and can cryptographically verify that a package belongs to a particular app ID.                               //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        //
//       collector should at some point check whether there are any other references and, if not,                      //
//       delete the package.                                                                                           //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    //
//     even if it has no users.                                                                                        //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           //
//     packager.                                                                                                       //
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages");                                                                     // 159
// List of packages currently made available via the dev tools running on the local machine.                           //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     //
// on the local machine to publish an under-development app to this server. That should only ever                      //
// happen on developers' desktop machines.                                                                             //
//                                                                                                                     //
// While a dev package is published, it automatically appears as installed by every user of the                        //
// server, and it overrides all packages with the same application ID. If any instances of those                       //
// packages are currently open, they are killed and reset on publish.                                                  //
//                                                                                                                     //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     //
// are again killed and refreshed.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  The package ID string (as with Packages._id).                                                               //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  //
//   timestamp:  Time when the package was last updated. If this changes while the package is                          //
//     published, all running instances are reset. This is used e.g. to reset the app each time                        //
//     changes are made to the source code.                                                                            //
//   manifest:  The app's manifest, as with Packages.manifest.                                                         //
                                                                                                                       //
UserActions = new Mongo.Collection("userActions");                                                                     // 180
// List of actions that each user has installed which create new grains.  Each app may install                         //
// some number of actions (usually, one).                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   userId:  Account ID of the user who has installed this action.                                                    //
//   packageId:  Package used to run this action.                                                                      //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 //
//       that clients can access it without subscribing to the Packages collection.                                    //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     //
//       `{defaultText: "New Spreadsheet"}`.                                                                           //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        //
//   command:  Manifest.Command to run this action (see package.capnp).                                                //
                                                                                                                       //
Grains = new Mongo.Collection("grains");                                                                               // 199
// Grains belonging to users.                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   packageId:  _id of the package of which this grain is an instance.                                                //
//   packageSalt: If present, a random string that will used in session ID generation. This field                      //
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            //
//       clients with active sessions.                                                                                 //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            //
//       searchability.                                                                                                //
//   userId: The _id of the account that owns this grain.                                                              //
//   identityId: The identity with which the owning account prefers to open this grain.                                //
//   title:  Human-readable string title, as chosen by the user.                                                       //
//   lastUsed:  Date when the grain was last used by a user.                                                           //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    //
//                   time a session to this grain was opened.                                                          //
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       //
//            this date, the grain will be automatically deleted.                                                      //
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        //
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        //
//   size: On-disk size of the grain in bytes.                                                                         //
//                                                                                                                     //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      //
// is implemented.                                                                                                     //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     //
//       web publishing. This field is initialized when first requested by the app.                                    //
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                             // 230
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             //
// collection.                                                                                                         //
                                                                                                                       //
Contacts = new Mongo.Collection("contacts");                                                                           // 235
// Edges in the social graph.                                                                                          //
//                                                                                                                     //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         //
// will show up in her user-picker UI for actions like share-by-identity.                                              //
//                                                                                                                     //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        //
// Bob's.                                                                                                              //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: random                                                                                                       //
//   ownerId: The accountId of the user account who owns this contact.                                                 //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        //
//            the contact to the owner.                                                                                //
//   created: Date when this contact was created.                                                                      //
//   identityId: The `_id` of the user whose contact info this contains.                                               //
                                                                                                                       //
Sessions = new Mongo.Collection("sessions");                                                                           // 252
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     //
//       client, and the grain's `packageSalt`.                                                                        //
//   grainId:  _id of the grain to which this session is connected.                                                    //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     //
//       '*' in WILDCARD_HOST.                                                                                         //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      //
//       have the same `tabId` as the outer session.                                                                   //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        //
//       period.                                                                                                       //
//   userId:  Account ID of the user who owns this session.                                                            //
//   identityId:  Identity ID of the user who owns this session.                                                       //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     //
//       are present.                                                                                                  //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                           //
//       interaction.                                                                                                  //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                   //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     //
//       until newSession is called on the UiView.                                                                     //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        //
//       until newSession is called on the UiView.                                                                     //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   //
//       request                                                                                                       //
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys");                                                                       // 282
// Invite keys which may be used by users to get access to Sandstorm.                                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:  random                                                                                                      //
//   used:  Boolean indicating whether this key has already been consumed.                                             //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          //
//   email: If this key was sent as an email invite, the email address to which it was sent.                           //
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats");                                                                 // 291
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   timestamp: Date when measurements were taken.                                                                     //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           //
//                                                                                                                     //
// Each of daily, weekly, and monthly contains:                                                                        //
//   activeUsers: The number of unique users who have used a grain on the server in the time                           //
//       interval. Only counts logged-in users.                                                                        //
//   demoUsers: Demo users.                                                                                            //
//   appDemoUsers: Users that came in through "app demo".                                                              //
//   activeGrains: The number of unique grains that have been used in the time interval.                               //
//   apps: An object indexed by app ID recording, for each app:                                                        //
//       owners: Number of unique owners of this app (counting only grains that still exist).                          //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    //
//         only grains that still exist).                                                                              //
//       grains: Number of active grains of this app (that still exist).                                               //
//       deleted: Number of non-demo grains of this app that were deleted.                                             //
//       demoed: Number of demo grains created and expired.                                                            //
//       appDemoUsers: Number of app demos initiated with this app.                                                    //
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats");                                                                     // 315
// Contains records of objects that were deleted, for stat-keeping purposes.                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             //
//   lastActive: Date of the user's or grain's last activity.                                                          //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     //
//     arrived to demo. For others, undefined.                                                                         //
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens");                                                                       // 324
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       //
// a token when they create a backup file (either by uploading it, or by backing up one of their                       //
// grains) and may use the token to read the file (either to download it, or to restore a new                          //
// grain from it).                                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The unguessable token string.                                                                          //
//   name:      Suggested filename.                                                                                    //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        //
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens");                                                                         // 335
// Access tokens for APIs exported by apps.                                                                            //
//                                                                                                                     //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         //
// `MainView`) -- the fields of type `Data` are API tokens.                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       //
//              That is, the UiView's newSession() method will intersect the requested permissions                     //
//              with this identity's permissions before forwarding on to the underlying app. If                        //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     //
//              this is NOT the identity against which the `requiredPermissions` parameter of                          //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    //
//              that created the token.                                                                                //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    //
//              permissions will be intersected with those held by `identityId` when the view is                       //
//              opened.                                                                                                //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    //
//              anonymous rather than as directly associated with `identityId`. This has no effect                     //
//              on the permissions granted.                                                                            //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      //
//              the app or its supervisor (whereas without this it strictly represents UiView).                        //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    //
//              containing exactly one of the following fields:                                                        //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           //
//                           `Notifications` collection.                                                               //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      //
//                  database when that happens. This field contains the boolean true to signify that                   //
//                  it has been set.                                                                                   //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           //
//                      value is an object containing the fields `id` and `services`. `id` is the                      //
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             //
//                      powerbox query for matching verified emails. `services` is a                                   //
//                      list of names of identity providers that are trusted to verify addresses.                      //
//                      If `services` is omitted or falsy, all configured identity providers are                       //
//                      trusted. Note that a malicious user could specify invalid names in the                         //
//                      list; they should be ignored.                                                                  //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               //
//                      An object containing `verifierId`, `tabId`, and `address`.                                     //
//       identity: An Identity capability. The field is the identity ID.                                               //
//   parentToken: If present, then this token represents exactly the capability represented by                         //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       //
//              is set to the identity that shared the view, and `accountId` is set to the account                     //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             //
//              `parentToken` is present.                                                                              //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          //
//              revocation. This should be displayed when visualizing incoming capabilities to                         //
//              the grain identified by `grainId`.                                                                     //
//   created:   Date when this token was created.                                                                      //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    //
//              become un-revoked in the future.                                                                       //
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     //
//              this date, the token will be automatically deleted.                                                    //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     //
//   lastUsed:  Optional Date when this token was last used.                                                           //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             //
//              as passed to the `save()` call that created this token. If not present, treat                          //
//              as `webkey` (the default for `ApiTokenOwner`).                                                         //
//   expiresIfUnused:                                                                                                  //
//              Optional Date after which the token, if it has not been used yet, expires.                             //
//              This field should be cleared on a token's first use.                                                   //
//   requirements: List of conditions which must hold for this token to be considered valid.                           //
//              Semantically, this list specifies the powers which were *used* to originally                           //
//              create the token. If any condition in the list becomes untrue, then the token must                     //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         //
//              through it must also become revoked. Each item is the JSON serialization of the                        //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          //
//              cleaned up when the token is.                                                                          //
//                                                                                                                     //
// It is important to note that a token's owner and provider are independent from each other. To                       //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    //
//                                                                                                                     //
// struct ApiToken {                                                                                                   //
//   owner :ApiTokenOwner;                                                                                             //
//   provider :union {                                                                                                 //
//     grain :group {                                                                                                  //
//       grainId :Text;                                                                                                //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment;                                                                           //
//           forSharing :Bool;                                                                                         //
//         }                                                                                                           //
//         objectId :SupervisorObjectId;                                                                               //
//       }                                                                                                             //
//     }                                                                                                               //
//     frontendRef :union {                                                                                            //
//       notificationHandle :Text;                                                                                     //
//       ipNetwork :Bool;                                                                                              //
//       ipInterface :Bool;                                                                                            //
//       emailVerifier :group {                                                                                        //
//         id :Text;                                                                                                   //
//         services :List(String);                                                                                     //
//       }                                                                                                             //
//       verifiedEmail :group {                                                                                        //
//         verifierId :Text;                                                                                           //
//         tabId :Text;                                                                                                //
//         address :Text;                                                                                              //
//       }                                                                                                             //
//       identity :Text;                                                                                               //
//     }                                                                                                               //
//     child :group {                                                                                                  //
//       parentToken :Text;                                                                                            //
//       union {                                                                                                       //
//         uiView :group {                                                                                             //
//           grainId :Text;                                                                                            //
//           identityId :Text;                                                                                         //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        //
//         }                                                                                                           //
//         other :Void;                                                                                                //
//       }                                                                                                             //
//     }                                                                                                               //
//   }                                                                                                                 //
//   requirements: List(Supervisor.MembraneRequirement);                                                               //
//   ...                                                                                                               //
// }                                                                                                                   //
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 471
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 472
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 473
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts");                                                                           // 475
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      //
// to probe an API host without authentication to determine capabilities such as DAV protocols                         //
// supported, before authenticating to perform real requests. An app can specify these properties                      //
// when creating an offerTemplate.                                                                                     //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     //
//                 up when ApiTokens are deleted.                                                                      //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          //
//                 This is an object containing fields:                                                                //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          //
//                 fields:                                                                                             //
//     type:       Content-Type.                                                                                       //
//     language:   Content-Language.                                                                                   //
//     encoding:   Content-Encoding.                                                                                   //
//     body:       Entity-body as a string or buffer.                                                                  //
                                                                                                                       //
Notifications = new Mongo.Collection("notifications");                                                                 // 500
// Notifications for a user.                                                                                           //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   grainId:      The grain originating this notification, if any.                                                    //
//   userId:       Account ID of the user receiving the notification.                                                  //
//   text:         The JSON-ified LocalizedText to display in the notification.                                        //
//   isUnread:     Boolean indicating if this notification is unread.                                                  //
//   timestamp:    Date when this notification was last updated                                                        //
//   eventType:    If this notification is due to an activity event, this is the numeric index                         //
//                 of the event type on the grain's ViewInfo.                                                          //
//   count:        The number of times this exact event has repeated. Identical events are                             //
//                 aggregated by incrementing the count.                                                               //
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      //
//   path:         Path inside the grain to which the user should be directed if they click on                         //
//                 the notification.                                                                                   //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             //
//                 ApiToken referencing the `OngoingNotification` capability.                                          //
//   admin:        If present, this is a notification intended for an admin.                                           //
//     action:     If present, this is a (string) link that the notification should direct the                         //
//                 admin to.                                                                                           //
//     type:       The type of notification (currently only "reportStats").                                            //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     //
//                 as keys.                                                                                            //
//     $appId:     The appId that has an outstanding update.                                                           //
//       packageId: The packageId that it will update to.                                                              //
//       name: The name of the app. (appTitle from package.manifest)                                                   //
//       version: The app's version number. (appVersion from package.manifest)                                         //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           //
//   referral:     If this boolean field is true, then treat this notification as a referral                           //
//                 notification. This causes text to be ignored, since we need custom logic.                           //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      //
//                 a one-time notification only to Oasis users who existed when the bonus program                      //
//                 was implemented.                                                                                    //
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions");                                                 // 536
// Activity events to which a user is subscribed.                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:          random                                                                                              //
//   identityId:   Who is subscribed.                                                                                  //
//   grainId:      Grain to which subscription applies.                                                                //
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       //
//                 whole grain.                                                                                        //
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         //
//                 This allows is useful to express:                                                                   //
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  //
//                 - The owner of a grain does not want notifications (normally, they are                              //
//                   implicitly subscribed).                                                                           //
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      //
//                   which they comment, so they mute the grain.                                                       //
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 553
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 554
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens");                                                                     // 556
// Access tokens for the Stats collection                                                                              //
//                                                                                                                     //
// These tokens are used for accessing the ActivityStats collection remotely                                           //
// (ie. from a dashboard webapp)                                                                                       //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  //
                                                                                                                       //
Misc = new Mongo.Collection("misc");                                                                                   // 565
// Miscellaneous configuration and other settings                                                                      //
//                                                                                                                     //
// This table is currently only used for persisting BASE_URL from one session to the next,                             //
// but in general any miscellaneous settings should go in here                                                         //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "BASE_URL"                                                                //
//   value:     The value of the setting.                                                                              //
                                                                                                                       //
Settings = new Mongo.Collection("settings");                                                                           // 575
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         //
// route. This collection differs from misc in that any admin user can update it through the admin                     //
// interface.                                                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       The name of the setting. eg. "smtpConfig"                                                              //
//   value:     The value of the setting.                                                                              //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     //
//                       so, it will also write an object to this field indicating why the reset was                   //
//                       needed. That object can have the following variants:                                          //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      //
//                           with the old BASE_URL.                                                                    //
//   preinstalledApps: A list of objects:                                                                              //
//     appId: The Packages.appId of the app to install                                                                 //
//     status: packageId                                                                                               //
//     packageId: The Packages._id of the app to install                                                               //
//                                                                                                                     //
//   potentially other fields that are unique to the setting                                                           //
                                                                                                                       //
Migrations = new Mongo.Collection("migrations");                                                                       // 595
// This table tracks which migrations we have applied to this instance.                                                //
// It contains a single entry:                                                                                         //
//   _id:       "migrations_applied"                                                                                   //
//   value:     The number of migrations this instance has successfully completed.                                     //
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets");                                                                   // 601
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            //
// support relatively small assets: under 1MB each.                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID; will be used in the URL.                                                                    //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    //
//   content:   The asset content (byte buffer).                                                                       //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        //
//       to catch leaked assets, although it's probably not a big deal in practice.                                    //
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                         // 615
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         //
// profile picture.                                                                                                    //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id:       Random ID.                                                                                             //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          //
//           userId: Account ID of user whose picture shall be replaced.                                               //
//           identityId: Which of the user's identities shall be updated.                                              //
//   expires:   Time when this token will go away if unused.                                                           //
                                                                                                                       //
Plans = new Mongo.Collection("plans");                                                                                 // 627
// Subscription plans, which determine quota.                                                                          //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                //
//   storage: Number of bytes this user is allowed to store.                                                           //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          //
//   computeLabel: Label to display to the user describing this plan's compute units.                                  //
//   grains: Total number of grains this user can create (often `Infinity`).                                           //
//   price: Price per month in US cents.                                                                               //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           //
//       allowed to switch away.                                                                                       //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      //
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex");                                                                           // 641
// A mirror of the data from the App Market index                                                                      //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: the appId of the app                                                                                         //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    //
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                             // 648
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     //
// by that user is installed, as well as if the keybase profile is requested and not already                           //
// present for some reason.                                                                                            //
//                                                                                                                     //
// Each contains:                                                                                                      //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    //
//   handle: Keybase handle.                                                                                           //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     //
//     server is currently actively checking this proof). Note that if a check fails due to network                    //
//     errors, the status goes back to "unverified".                                                                   //
//                                                                                                                     //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          //
//       for now and we just trust Keybase.                                                                            //
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey");                                                                       // 668
// Responsible for storing the current feature key that is active on the server.  Contains a single                    //
// document with two keys:                                                                                             //
//                                                                                                                     //
//   _id: "currentFeatureKey"                                                                                          //
//   value: the still-signed, binary-encoded feature key                                                               //
//          (a feature key with comments removed and base64 decoded)                                                   //
//                                                                                                                     //
// This is only intended to be visible on the server.                                                                  //
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession");                                                                   // 678
// Responsible for storing information about setup sessions.  Contains a single document with three                    //
// keys:                                                                                                               //
//                                                                                                                     //
//   _id: "current-session"                                                                                            //
//   creationDate: Date object indicating when this session was created.                                               //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              //
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications");                                               // 686
// Responsible for very short-lived queueing of desktop notification information.                                      //
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        //
// odd in that it is intended primarily for edge-triggered communications, but                                         //
// Meteor's collections aren't really designed to support that organization.                                           //
// Fields for each :                                                                                                   //
//                                                                                                                     //
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            //
//   creationDate: Date object. indicating when this notification was posted.                                          //
//   userId: String. Account id to which this notification was published.                                              //
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   //
//                            notification is activated.                                                               //
//   appActivity: Object with fields:                                                                                  //
//     user: {               The user whose action caused this notification.                                           //
//       name: String,       The user's display name.                                                                  //
//       avatarUrl: String,  The URL for the user's profile picture.                                                   //
//     },                                                                                                              //
//     grainId: String,      Which grain this action took place on                                                     //
//     path: String,         The path of the notification.                                                             //
//     body: Util.LocalizedText,  The main body of the activity event.                                                 //
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 //
//                                     { defaultText: "added a comment" }                                              //
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 709
  Meteor.publish("credentials", function () {                                                                          // 710
    // Data needed for isSignedUp() and isAdmin() to work.                                                             //
                                                                                                                       //
    if (this.userId) {                                                                                                 // 713
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 717
          referredIdentityIds: 1, cachedStorageQuota: 1 } }), Plans.find()];                                           // 718
    } else {                                                                                                           // 721
      return [];                                                                                                       // 722
    }                                                                                                                  // 723
  });                                                                                                                  // 724
}                                                                                                                      // 725
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 727
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 728
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 729
};                                                                                                                     // 730
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 732
  // This function returns an object of the form:                                                                      //
  //                                                                                                                   //
  // - {grains: 0, storage: 0}                                                                                         //
  //                                                                                                                   //
  // which are extra resources this account gets as part of participating in the referral                              //
  // program. (Storage is measured in bytes, as usual for plans.)                                                      //
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        //
  //   payments-specific) and aggregating into `planBonus`.                                                            //
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              //
  var isPaid = user.plan && user.plan !== "free";                                                                      // 744
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 746
  if (isPaid) {                                                                                                        // 747
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 748
    return { grains: 0,                                                                                                // 749
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 750
  } else {                                                                                                             // 753
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 754
    var bonus = {                                                                                                      // 755
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 756
    };                                                                                                                 // 755
    if (successfulReferralsCount > 0) {                                                                                // 760
      bonus.grains = Infinity;                                                                                         // 761
    } else {                                                                                                           // 762
      bonus.grains = 0;                                                                                                // 763
    }                                                                                                                  // 764
                                                                                                                       //
    return bonus;                                                                                                      // 766
  }                                                                                                                    // 767
};                                                                                                                     // 768
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 770
  // Returns true if the user is the administrator.                                                                    //
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 773
  if (user && user.isAdmin) {                                                                                          // 774
    return true;                                                                                                       // 775
  } else {                                                                                                             // 776
    return false;                                                                                                      // 777
  }                                                                                                                    // 778
};                                                                                                                     // 779
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 781
  // Returns true if the user's id is the administrator.                                                               //
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 784
  if (user && user.isAdmin) {                                                                                          // 785
    return true;                                                                                                       // 786
  } else {                                                                                                             // 787
    return false;                                                                                                      // 788
  }                                                                                                                    // 789
};                                                                                                                     // 790
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 792
  if (!token.requirements) {                                                                                           // 793
    return;                                                                                                            // 794
  }                                                                                                                    // 795
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 797
    return "userIsAdmin" in requirement;                                                                               // 798
  });                                                                                                                  // 799
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 801
    return;                                                                                                            // 802
  }                                                                                                                    // 803
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 805
    return;                                                                                                            // 806
  }                                                                                                                    // 807
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 809
};                                                                                                                     // 810
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 812
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 814
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 815
}                                                                                                                      // 816
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 818
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           //
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    //
  // comparison logic ignores port numbers.                                                                            //
  var prefix = wildcardHost[0];                                                                                        // 823
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 824
  var hostSansPort = host.split(":")[0];                                                                               // 825
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 830
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 831
      return id;                                                                                                       // 832
    }                                                                                                                  // 833
  }                                                                                                                    // 834
                                                                                                                       //
  return null;                                                                                                         // 836
};                                                                                                                     // 837
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 839
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 840
};                                                                                                                     // 841
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 843
  if (hostId) {                                                                                                        // 844
    var split = hostId.split("-");                                                                                     // 845
    if (split[0] === "api") return split[1] || "*";                                                                    // 846
  }                                                                                                                    // 847
                                                                                                                       //
  return false;                                                                                                        // 849
};                                                                                                                     // 850
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 852
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 853
};                                                                                                                     // 854
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 856
if (Meteor.isServer) {                                                                                                 // 857
  (function () {                                                                                                       // 857
    var Crypto = Npm.require("crypto");                                                                                // 858
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 859
      // Given an API token, compute the host ID that must be used when requesting this token.                         //
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     //
      // any bugs which would allow someone who knows only the hostname to access the app API.                         //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 866
    };                                                                                                                 // 867
  })();                                                                                                                // 857
} else {                                                                                                               // 868
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 869
    // Given an API token, compute the host ID that must be used when requesting this token.                           //
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       //
    // any bugs which would allow someone who knows only the hostname to access the app API.                           //
    return SHA256("x" + token).slice(0, 32);                                                                           // 876
  };                                                                                                                   // 877
}                                                                                                                      // 878
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 880
  return "api-" + apiHostIdHashForToken(token);                                                                        // 881
};                                                                                                                     // 882
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 884
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 885
};                                                                                                                     // 886
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 888
  (function () {                                                                                                       // 888
    var Url = Npm.require("url");                                                                                      // 889
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 890
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              //
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 898
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 900
      if (dotPos < 0) {                                                                                                // 901
        return protocol + "//*";                                                                                       // 902
      } else {                                                                                                         // 903
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 904
      }                                                                                                                // 905
    };                                                                                                                 // 906
  })();                                                                                                                // 888
}                                                                                                                      // 907
                                                                                                                       //
allowDevAccounts = function allowDevAccounts() {                                                                       // 909
  var setting = Settings.findOne({ _id: "devAccounts" });                                                              // 910
  if (setting) {                                                                                                       // 911
    return setting.value;                                                                                              // 912
  } else {                                                                                                             // 913
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                 // 914
  }                                                                                                                    // 916
};                                                                                                                     // 917
                                                                                                                       //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                   // 919
  Notifications.upsert({                                                                                               // 920
    userId: userId,                                                                                                    // 921
    referral: true                                                                                                     // 922
  }, {                                                                                                                 // 920
    userId: userId,                                                                                                    // 924
    referral: true,                                                                                                    // 925
    timestamp: new Date(),                                                                                             // 926
    isUnread: true                                                                                                     // 927
  });                                                                                                                  // 923
};                                                                                                                     // 929
                                                                                                                       //
roleAssignmentPattern = {                                                                                              // 931
  none: Match.Optional(null),                                                                                          // 932
  allAccess: Match.Optional(null),                                                                                     // 933
  roleId: Match.Optional(Match.Integer),                                                                               // 934
  addPermissions: Match.Optional([Boolean]),                                                                           // 935
  removePermissions: Match.Optional([Boolean])                                                                         // 936
};                                                                                                                     // 931
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 939
  // quotaManager is an object with the following method:                                                              //
  //   updateUserQuota: It is provided two arguments                                                                   //
  //     db: This SandstormDb object                                                                                   //
  //     user: A collections.users account object                                                                      //
  //   and returns a quota object:                                                                                     //
  //     storage: A number (can be Infinity)                                                                           //
  //     compute: A number (can be Infinity)                                                                           //
  //     grains: A number (can be Infinity)                                                                            //
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 949
  this.collections = {                                                                                                 // 950
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    //
    // collection globals directly.                                                                                    //
    //                                                                                                                 //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      //
    //   direct access to the collections.                                                                             //
    users: Meteor.users,                                                                                               // 956
                                                                                                                       //
    packages: Packages,                                                                                                // 958
    devPackages: DevPackages,                                                                                          // 959
    userActions: UserActions,                                                                                          // 960
    grains: Grains,                                                                                                    // 961
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 962
    contacts: Contacts,                                                                                                // 963
    sessions: Sessions,                                                                                                // 964
    signupKeys: SignupKeys,                                                                                            // 965
    activityStats: ActivityStats,                                                                                      // 966
    deleteStats: DeleteStats,                                                                                          // 967
    fileTokens: FileTokens,                                                                                            // 968
    apiTokens: ApiTokens,                                                                                              // 969
    apiHosts: ApiHosts,                                                                                                // 970
    notifications: Notifications,                                                                                      // 971
    // Omitted: ActivitySubscriptions                                                                                  //
    statsTokens: StatsTokens,                                                                                          // 973
    misc: Misc,                                                                                                        // 974
    settings: Settings,                                                                                                // 975
    migrations: Migrations,                                                                                            // 976
    // Omitted: StaticAssets                                                                                           //
    // Omitted: AssetUploadTokens                                                                                      //
    plans: Plans,                                                                                                      // 979
    appIndex: AppIndex,                                                                                                // 980
    keybaseProfiles: KeybaseProfiles,                                                                                  // 981
    featureKey: FeatureKey,                                                                                            // 982
    setupSession: SetupSession,                                                                                        // 983
    desktopNotifications: DesktopNotifications                                                                         // 984
  };                                                                                                                   // 950
};                                                                                                                     // 986
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           //
//   objects created in SandstormDb's constructor rather than globals.                                                 //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 991
  isAdmin: isAdmin,                                                                                                    // 992
  isAdminById: isAdminById,                                                                                            // 993
  findAdminUserForToken: findAdminUserForToken,                                                                        // 994
  matchWildcardHost: matchWildcardHost,                                                                                // 995
  makeWildcardHost: makeWildcardHost,                                                                                  // 996
  isApiHostId: isApiHostId,                                                                                            // 997
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 998
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 999
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1000
  makeApiHost: makeApiHost,                                                                                            // 1001
  allowDevAccounts: allowDevAccounts,                                                                                  // 1002
  roleAssignmentPattern: roleAssignmentPattern,                                                                        // 1003
                                                                                                                       //
  isDemoUser: function isDemoUser() {                                                                                  // 1005
    // Returns true if this is a demo user.                                                                            //
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1008
    if (user && user.expires) {                                                                                        // 1009
      return true;                                                                                                     // 1010
    } else {                                                                                                           // 1011
      return false;                                                                                                    // 1012
    }                                                                                                                  // 1013
  },                                                                                                                   // 1014
                                                                                                                       //
  isSignedUp: function isSignedUp() {                                                                                  // 1016
    var user = Meteor.user();                                                                                          // 1017
    return this.isAccountSignedUp(user);                                                                               // 1018
  },                                                                                                                   // 1019
                                                                                                                       //
  isAccountSignedUp: function isAccountSignedUp(user) {                                                                // 1021
    // Returns true if the user has presented an invite key.                                                           //
                                                                                                                       //
    if (!user) return false; // not signed in                                                                          // 1024
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1026
                                                                                                                       //
    if (user.expires) return false; // demo user.                                                                      // 1028
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1030
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1032
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1034
                                                                                                                       //
    return false;                                                                                                      // 1036
  },                                                                                                                   // 1037
                                                                                                                       //
  isSignedUpOrDemo: function isSignedUpOrDemo() {                                                                      // 1039
    var user = Meteor.user();                                                                                          // 1040
    return this.isAccountSignedUpOrDemo(user);                                                                         // 1041
  },                                                                                                                   // 1042
                                                                                                                       //
  isAccountSignedUpOrDemo: function isAccountSignedUpOrDemo(user) {                                                    // 1044
    if (!user) return false; // not signed in                                                                          // 1045
                                                                                                                       //
    if (!user.loginIdentities) return false; // not an account                                                         // 1047
                                                                                                                       //
    if (user.expires) return true; // demo user.                                                                       // 1049
                                                                                                                       //
    if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                                 // 1051
                                                                                                                       //
    if (user.signupKey) return true; // user is invited                                                                // 1053
                                                                                                                       //
    if (this.isUserInOrganization(user)) return true;                                                                  // 1055
                                                                                                                       //
    return false;                                                                                                      // 1057
  },                                                                                                                   // 1058
                                                                                                                       //
  isIdentityInOrganization: function isIdentityInOrganization(identity) {                                              // 1060
    if (!identity || !identity.services) {                                                                             // 1061
      return false;                                                                                                    // 1062
    }                                                                                                                  // 1063
                                                                                                                       //
    var orgMembership = this.getOrganizationMembership();                                                              // 1065
    var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                         // 1066
    var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                           // 1067
    var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                  // 1068
    var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                    // 1069
    var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                               // 1070
    var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                               // 1071
    if (emailEnabled && emailDomain && identity.services.email) {                                                      // 1072
      if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                              // 1073
        return true;                                                                                                   // 1074
      }                                                                                                                // 1075
    } else if (ldapEnabled && identity.services.ldap) {                                                                // 1076
      return true;                                                                                                     // 1077
    } else if (samlEnabled && identity.services.saml) {                                                                // 1078
      return true;                                                                                                     // 1079
    } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {             // 1080
      if (identity.services.google.hd.toLowerCase() === googleDomain) {                                                // 1081
        return true;                                                                                                   // 1082
      }                                                                                                                // 1083
    }                                                                                                                  // 1084
                                                                                                                       //
    return false;                                                                                                      // 1086
  },                                                                                                                   // 1087
                                                                                                                       //
  isUserInOrganization: function isUserInOrganization(user) {                                                          // 1089
    if (!this.isFeatureKeyValid()) {                                                                                   // 1090
      return false;                                                                                                    // 1091
    }                                                                                                                  // 1092
                                                                                                                       //
    for (var i = 0; i < user.loginIdentities.length; i++) {                                                            // 1094
      var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                        // 1095
      if (this.isIdentityInOrganization(identity)) {                                                                   // 1096
        return true;                                                                                                   // 1097
      }                                                                                                                // 1098
    }                                                                                                                  // 1099
                                                                                                                       //
    return false;                                                                                                      // 1101
  }                                                                                                                    // 1102
});                                                                                                                    // 991
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1105
  (function () {                                                                                                       // 1105
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1106
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1108
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1109
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           //
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1112
        // Clean up ApiHosts for webkey tokens.                                                                        //
        if (token.hasApiHost) {                                                                                        // 1114
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1115
          ApiHosts.remove({ hash2: hash2 });                                                                           // 1116
        }                                                                                                              // 1117
      });                                                                                                              // 1118
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1120
    };                                                                                                                 // 1121
  })();                                                                                                                // 1105
}                                                                                                                      // 1122
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            //
// appears all over the codebase.                                                                                      //
var httpProtocol = void 0;                                                                                             // 1126
if (Meteor.isServer) {                                                                                                 // 1127
  var _Url = Npm.require("url");                                                                                       // 1128
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1129
} else {                                                                                                               // 1130
  httpProtocol = window.location.protocol;                                                                             // 1131
}                                                                                                                      // 1132
                                                                                                                       //
// =======================================================================================                             //
// Below this point are newly-written or refactored functions.                                                         //
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1137
  getUser: function getUser(userId) {                                                                                  // 1138
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1139
    if (userId) {                                                                                                      // 1140
      return Meteor.users.findOne(userId);                                                                             // 1141
    }                                                                                                                  // 1142
  },                                                                                                                   // 1143
                                                                                                                       //
  getIdentity: function getIdentity(identityId) {                                                                      // 1145
    check(identityId, String);                                                                                         // 1146
    var identity = Meteor.users.findOne({ _id: identityId });                                                          // 1147
    if (identity) {                                                                                                    // 1148
      SandstormDb.fillInProfileDefaults(identity);                                                                     // 1149
      SandstormDb.fillInIntrinsicName(identity);                                                                       // 1150
      SandstormDb.fillInPictureUrl(identity);                                                                          // 1151
      return identity;                                                                                                 // 1152
    }                                                                                                                  // 1153
  },                                                                                                                   // 1154
                                                                                                                       //
  userHasIdentity: function userHasIdentity(userId, identityId) {                                                      // 1156
    check(userId, String);                                                                                             // 1157
    check(identityId, String);                                                                                         // 1158
                                                                                                                       //
    if (userId === identityId) return true;                                                                            // 1160
                                                                                                                       //
    var user = Meteor.users.findOne(userId);                                                                           // 1162
    return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                             // 1163
  },                                                                                                                   // 1164
                                                                                                                       //
  userGrains: function userGrains(userId, trashed) {                                                                   // 1166
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1167
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1168
                                                                                                                       //
    return this.collections.grains.find({ userId: userId, trashed: { $exists: !!trashed } });                          // 1170
  },                                                                                                                   // 1171
                                                                                                                       //
  currentUserGrains: function currentUserGrains(trashed) {                                                             // 1173
    return this.userGrains(Meteor.userId(), trashed);                                                                  // 1174
  },                                                                                                                   // 1175
                                                                                                                       //
  getGrain: function getGrain(grainId) {                                                                               // 1177
    check(grainId, String);                                                                                            // 1178
    return this.collections.grains.findOne(grainId);                                                                   // 1179
  },                                                                                                                   // 1180
                                                                                                                       //
  userApiTokens: function userApiTokens(userId, trashed) {                                                             // 1182
    check(userId, Match.OneOf(String, undefined, null));                                                               // 1183
    check(trashed, Match.OneOf(Boolean, undefined, null));                                                             // 1184
    var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                            // 1185
    return this.collections.apiTokens.find({                                                                           // 1186
      "owner.user.identityId": { $in: identityIds },                                                                   // 1187
      trashed: { $exists: !!trashed }                                                                                  // 1188
    });                                                                                                                // 1186
  },                                                                                                                   // 1190
                                                                                                                       //
  currentUserApiTokens: function currentUserApiTokens(trashed) {                                                       // 1192
    return this.userApiTokens(Meteor.userId(), trashed);                                                               // 1193
  },                                                                                                                   // 1194
                                                                                                                       //
  userActions: function userActions(user) {                                                                            // 1196
    return this.collections.userActions.find({ userId: user });                                                        // 1197
  },                                                                                                                   // 1198
                                                                                                                       //
  currentUserActions: function currentUserActions() {                                                                  // 1200
    return this.userActions(Meteor.userId());                                                                          // 1201
  },                                                                                                                   // 1202
                                                                                                                       //
  iconSrcForPackage: function iconSrcForPackage(pkg, usage) {                                                          // 1204
    return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));             // 1205
  },                                                                                                                   // 1206
                                                                                                                       //
  getDenormalizedGrainInfo: function getDenormalizedGrainInfo(grainId) {                                               // 1208
    var grain = this.getGrain(grainId);                                                                                // 1209
    var pkg = this.collections.packages.findOne(grain.packageId);                                                      // 1210
                                                                                                                       //
    if (!pkg) {                                                                                                        // 1212
      pkg = this.collections.devPackages.findOne(grain.packageId);                                                     // 1213
    }                                                                                                                  // 1214
                                                                                                                       //
    var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                                // 1216
    var grainInfo = { appTitle: appTitle };                                                                            // 1217
                                                                                                                       //
    if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                                 // 1219
      var icons = pkg.manifest.metadata.icons;                                                                         // 1220
      grainInfo.icon = icons.grain || icons.appGrid;                                                                   // 1221
    }                                                                                                                  // 1222
                                                                                                                       //
    // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                      //
    if (!grainInfo.icon && pkg) {                                                                                      // 1225
      grainInfo.appId = pkg.appId;                                                                                     // 1226
    }                                                                                                                  // 1227
                                                                                                                       //
    return grainInfo;                                                                                                  // 1229
  },                                                                                                                   // 1230
                                                                                                                       //
  getPlan: function getPlan(id) {                                                                                      // 1232
    check(id, String);                                                                                                 // 1233
    var plan = Plans.findOne(id);                                                                                      // 1234
    if (!plan) {                                                                                                       // 1235
      throw new Error("no such plan: " + id);                                                                          // 1236
    }                                                                                                                  // 1237
                                                                                                                       //
    return plan;                                                                                                       // 1239
  },                                                                                                                   // 1240
                                                                                                                       //
  listPlans: function listPlans() {                                                                                    // 1242
    return Plans.find({}, { sort: { price: 1 } });                                                                     // 1243
  },                                                                                                                   // 1244
                                                                                                                       //
  getMyPlan: function getMyPlan() {                                                                                    // 1246
    var user = Meteor.user();                                                                                          // 1247
    return user && Plans.findOne(user.plan || "free");                                                                 // 1248
  },                                                                                                                   // 1249
                                                                                                                       //
  getMyReferralBonus: function getMyReferralBonus(user) {                                                              // 1251
    // This function is called from the server and from the client, similar to getMyPlan().                            //
    //                                                                                                                 //
    // The parameter may be omitted in which case the current user is assumed.                                         //
                                                                                                                       //
    return calculateReferralBonus(user || Meteor.user());                                                              // 1256
  },                                                                                                                   // 1257
                                                                                                                       //
  getMyUsage: function getMyUsage(user) {                                                                              // 1259
    user = user || Meteor.user();                                                                                      // 1260
    if (user && (Meteor.isServer || user.pseudoUsage)) {                                                               // 1261
      if (Meteor.isClient) {                                                                                           // 1262
        // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                       //
        // not reactive.                                                                                               //
        return user.pseudoUsage;                                                                                       // 1265
      } else {                                                                                                         // 1266
        return {                                                                                                       // 1267
          grains: Grains.find({ userId: user._id }).count(),                                                           // 1268
          storage: user.storageUsage || 0,                                                                             // 1269
          compute: 0 };                                                                                                // 1270
      }                                                                                                                // 1272
    } else // not tracked yet                                                                                          // 1273
      {                                                                                                                // 1273
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1274
      }                                                                                                                // 1275
  },                                                                                                                   // 1276
                                                                                                                       //
  isUninvitedFreeUser: function isUninvitedFreeUser() {                                                                // 1278
    if (!Meteor.settings["public"].allowUninvited) return false;                                                       // 1279
                                                                                                                       //
    var user = Meteor.user();                                                                                          // 1281
    return user && !user.expires && (!user.plan || user.plan === "free");                                              // 1282
  },                                                                                                                   // 1283
                                                                                                                       //
  getSetting: function getSetting(name) {                                                                              // 1285
    var setting = Settings.findOne(name);                                                                              // 1286
    return setting && setting.value;                                                                                   // 1287
  },                                                                                                                   // 1288
                                                                                                                       //
  getSettingWithFallback: function getSettingWithFallback(name, fallbackValue) {                                       // 1290
    var value = this.getSetting(name);                                                                                 // 1291
    if (value === undefined) {                                                                                         // 1292
      return fallbackValue;                                                                                            // 1293
    }                                                                                                                  // 1294
                                                                                                                       //
    return value;                                                                                                      // 1296
  },                                                                                                                   // 1297
                                                                                                                       //
  addUserActions: function addUserActions(userId, packageId, simulation) {                                             // 1299
    check(userId, String);                                                                                             // 1300
    check(packageId, String);                                                                                          // 1301
                                                                                                                       //
    var pack = Packages.findOne({ _id: packageId });                                                                   // 1303
    if (pack) {                                                                                                        // 1304
      // Remove old versions.                                                                                          //
      var numRemoved = UserActions.remove({ userId: userId, appId: pack.appId });                                      // 1306
                                                                                                                       //
      // Install new.                                                                                                  //
      var actions = pack.manifest.actions;                                                                             // 1309
      for (var i in actions) {                                                                                         // 1310
        var action = actions[i];                                                                                       // 1311
        if ("none" in action.input) {                                                                                  // 1312
          var userAction = {                                                                                           // 1313
            userId: userId,                                                                                            // 1314
            packageId: pack._id,                                                                                       // 1315
            appId: pack.appId,                                                                                         // 1316
            appTitle: pack.manifest.appTitle,                                                                          // 1317
            appMarketingVersion: pack.manifest.appMarketingVersion,                                                    // 1318
            appVersion: pack.manifest.appVersion,                                                                      // 1319
            title: action.title,                                                                                       // 1320
            nounPhrase: action.nounPhrase,                                                                             // 1321
            command: action.command                                                                                    // 1322
          };                                                                                                           // 1313
          UserActions.insert(userAction);                                                                              // 1324
        } else {                                                                                                       // 1325
          // TODO(someday):  Implement actions with capability inputs.                                                 //
        }                                                                                                              // 1327
      }                                                                                                                // 1328
                                                                                                                       //
      if (numRemoved > 0 && !simulation) {                                                                             // 1330
        this.deleteUnusedPackages(pack.appId);                                                                         // 1331
      }                                                                                                                // 1332
    }                                                                                                                  // 1333
  },                                                                                                                   // 1334
                                                                                                                       //
  sendAdminNotification: function sendAdminNotification(message, link) {                                               // 1336
    Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                             // 1337
      Notifications.insert({                                                                                           // 1338
        admin: {                                                                                                       // 1339
          action: link,                                                                                                // 1340
          type: "reportStats"                                                                                          // 1341
        },                                                                                                             // 1339
        userId: user._id,                                                                                              // 1343
        text: { defaultText: message },                                                                                // 1344
        timestamp: new Date(),                                                                                         // 1345
        isUnread: true                                                                                                 // 1346
      });                                                                                                              // 1338
    });                                                                                                                // 1348
  },                                                                                                                   // 1349
                                                                                                                       //
  getKeybaseProfile: function getKeybaseProfile(keyFingerprint) {                                                      // 1351
    return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                             // 1352
  },                                                                                                                   // 1353
                                                                                                                       //
  getServerTitle: function getServerTitle() {                                                                          // 1355
    var setting = Settings.findOne({ _id: "serverTitle" });                                                            // 1356
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1357
  },                                                                                                                   // 1358
                                                                                                                       //
  getSmtpConfig: function getSmtpConfig() {                                                                            // 1360
    var setting = Settings.findOne({ _id: "smtpConfig" });                                                             // 1361
    return setting ? setting.value : undefined; // undefined if subscription is not ready.                             // 1362
  },                                                                                                                   // 1363
                                                                                                                       //
                                                                                                                       //
  getReturnAddress: function getReturnAddress() {                                                                      // 1365
    var config = this.getSmtpConfig();                                                                                 // 1366
    return config && config.returnAddress || ""; // empty if subscription is not ready.                                // 1367
  },                                                                                                                   // 1368
                                                                                                                       //
  getReturnAddressWithDisplayName: function getReturnAddressWithDisplayName(identityId) {                              // 1370
    check(identityId, String);                                                                                         // 1371
    var identity = this.getIdentity(identityId);                                                                       // 1372
    var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                  // 1373
                                                                                                                       //
    // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                            //
    // we could escape such characters with a backslash, but that does not seem to help here.                          //
    var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                           // 1377
                                                                                                                       //
    return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                                  // 1379
  },                                                                                                                   // 1380
                                                                                                                       //
  getPrimaryEmail: function getPrimaryEmail(accountId, identityId) {                                                   // 1382
    check(accountId, String);                                                                                          // 1383
    check(identityId, String);                                                                                         // 1384
                                                                                                                       //
    var identity = this.getIdentity(identityId);                                                                       // 1386
    var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                        // 1387
    var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                             // 1388
    var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                             // 1389
    if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                            // 1390
      return accountPrimaryEmailAddress;                                                                               // 1391
    } else if (senderPrimaryEmail) {                                                                                   // 1392
      return senderPrimaryEmail.email;                                                                                 // 1393
    } else {                                                                                                           // 1394
      return null;                                                                                                     // 1395
    }                                                                                                                  // 1396
  },                                                                                                                   // 1397
                                                                                                                       //
  incrementDailySentMailCount: function incrementDailySentMailCount(accountId) {                                       // 1399
    check(accountId, String);                                                                                          // 1400
                                                                                                                       //
    var DAILY_LIMIT = 50;                                                                                              // 1402
    var result = Meteor.users.findAndModify({                                                                          // 1403
      query: { _id: accountId },                                                                                       // 1404
      update: {                                                                                                        // 1405
        $inc: {                                                                                                        // 1406
          dailySentMailCount: 1                                                                                        // 1407
        }                                                                                                              // 1406
      },                                                                                                               // 1405
      fields: { dailySentMailCount: 1 }                                                                                // 1410
    });                                                                                                                // 1403
                                                                                                                       //
    if (!result.ok) {                                                                                                  // 1413
      throw new Error("Couldn't update daily sent mail count.");                                                       // 1414
    }                                                                                                                  // 1415
                                                                                                                       //
    var user = result.value;                                                                                           // 1417
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 1418
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  // 1423
  },                                                                                                                   // 1424
                                                                                                                       //
  isFeatureKeyValid: function isFeatureKeyValid() {                                                                    // 1426
    var featureKey = this.currentFeatureKey();                                                                         // 1427
    return !!featureKey;                                                                                               // 1428
  },                                                                                                                   // 1429
                                                                                                                       //
  isFeatureKeyValidAndNotExpired: function isFeatureKeyValidAndNotExpired() {                                          // 1431
    var featureKey = this.currentFeatureKey();                                                                         // 1432
    return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                             // 1433
  },                                                                                                                   // 1434
                                                                                                                       //
  getLdapUrl: function getLdapUrl() {                                                                                  // 1436
    var setting = Settings.findOne({ _id: "ldapUrl" });                                                                // 1437
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1438
  },                                                                                                                   // 1439
                                                                                                                       //
  getLdapBase: function getLdapBase() {                                                                                // 1441
    var setting = Settings.findOne({ _id: "ldapBase" });                                                               // 1442
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1443
  },                                                                                                                   // 1444
                                                                                                                       //
  getLdapDnPattern: function getLdapDnPattern() {                                                                      // 1446
    var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                          // 1447
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1448
  },                                                                                                                   // 1449
                                                                                                                       //
  getLdapSearchUsername: function getLdapSearchUsername() {                                                            // 1451
    var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                     // 1452
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1453
  },                                                                                                                   // 1454
                                                                                                                       //
  getLdapNameField: function getLdapNameField() {                                                                      // 1456
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 1457
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1458
  },                                                                                                                   // 1459
                                                                                                                       //
  getLdapEmailField: function getLdapEmailField() {                                                                    // 1461
    var setting = Settings.findOne({ _id: "ldapEmailField" });                                                         // 1462
    return setting ? setting.value : "mail";                                                                           // 1463
    // default to "mail". This setting was added later, and so could potentially be unset.                             //
  },                                                                                                                   // 1465
                                                                                                                       //
  getLdapExplicitDnSelected: function getLdapExplicitDnSelected() {                                                    // 1467
    var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                                 // 1468
    return setting && setting.value;                                                                                   // 1469
  },                                                                                                                   // 1470
                                                                                                                       //
  getLdapFilter: function getLdapFilter() {                                                                            // 1472
    var setting = Settings.findOne({ _id: "ldapFilter" });                                                             // 1473
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1474
  },                                                                                                                   // 1475
                                                                                                                       //
  getLdapSearchBindDn: function getLdapSearchBindDn() {                                                                // 1477
    var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                       // 1478
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1479
  },                                                                                                                   // 1480
                                                                                                                       //
  getLdapSearchBindPassword: function getLdapSearchBindPassword() {                                                    // 1482
    var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                                 // 1483
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1484
  },                                                                                                                   // 1485
                                                                                                                       //
  getOrganizationMembership: function getOrganizationMembership() {                                                    // 1487
    var setting = Settings.findOne({ _id: "organizationMembership" });                                                 // 1488
    return setting && setting.value;                                                                                   // 1489
  },                                                                                                                   // 1490
                                                                                                                       //
  getOrganizationEmailEnabled: function getOrganizationEmailEnabled() {                                                // 1492
    var membership = this.getOrganizationMembership();                                                                 // 1493
    return membership && membership.emailToken && membership.emailToken.enabled;                                       // 1494
  },                                                                                                                   // 1495
                                                                                                                       //
  getOrganizationEmailDomain: function getOrganizationEmailDomain() {                                                  // 1497
    var membership = this.getOrganizationMembership();                                                                 // 1498
    return membership && membership.emailToken && membership.emailToken.domain;                                        // 1499
  },                                                                                                                   // 1500
                                                                                                                       //
  getOrganizationGoogleEnabled: function getOrganizationGoogleEnabled() {                                              // 1502
    var membership = this.getOrganizationMembership();                                                                 // 1503
    return membership && membership.google && membership.google.enabled;                                               // 1504
  },                                                                                                                   // 1505
                                                                                                                       //
  getOrganizationGoogleDomain: function getOrganizationGoogleDomain() {                                                // 1507
    var membership = this.getOrganizationMembership();                                                                 // 1508
    return membership && membership.google && membership.google.domain;                                                // 1509
  },                                                                                                                   // 1510
                                                                                                                       //
  getOrganizationLdapEnabled: function getOrganizationLdapEnabled() {                                                  // 1512
    var membership = this.getOrganizationMembership();                                                                 // 1513
    return membership && membership.ldap && membership.ldap.enabled;                                                   // 1514
  },                                                                                                                   // 1515
                                                                                                                       //
  getOrganizationSamlEnabled: function getOrganizationSamlEnabled() {                                                  // 1517
    var membership = this.getOrganizationMembership();                                                                 // 1518
    return membership && membership.saml && membership.saml.enabled;                                                   // 1519
  },                                                                                                                   // 1520
                                                                                                                       //
  getOrganizationDisallowGuests: function getOrganizationDisallowGuests() {                                            // 1522
    return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                        // 1523
  },                                                                                                                   // 1524
                                                                                                                       //
  getOrganizationDisallowGuestsRaw: function getOrganizationDisallowGuestsRaw() {                                      // 1526
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1527
    return setting && setting.value && setting.value.disallowGuests;                                                   // 1528
  },                                                                                                                   // 1529
                                                                                                                       //
  getOrganizationShareContacts: function getOrganizationShareContacts() {                                              // 1531
    return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                         // 1532
  },                                                                                                                   // 1533
                                                                                                                       //
  getOrganizationShareContactsRaw: function getOrganizationShareContactsRaw() {                                        // 1535
    var setting = Settings.findOne({ _id: "organizationSettings" });                                                   // 1536
    if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                     // 1537
      // default to true if undefined                                                                                  //
      return true;                                                                                                     // 1539
    } else {                                                                                                           // 1540
      return setting.value.shareContacts;                                                                              // 1541
    }                                                                                                                  // 1542
  },                                                                                                                   // 1543
                                                                                                                       //
  getSamlEntryPoint: function getSamlEntryPoint() {                                                                    // 1545
    var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                         // 1546
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1547
  },                                                                                                                   // 1548
                                                                                                                       //
  getSamlPublicCert: function getSamlPublicCert() {                                                                    // 1550
    var setting = Settings.findOne({ _id: "samlPublicCert" });                                                         // 1551
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1552
  },                                                                                                                   // 1553
                                                                                                                       //
  getSamlEntityId: function getSamlEntityId() {                                                                        // 1555
    var setting = Settings.findOne({ _id: "samlEntityId" });                                                           // 1556
    return setting ? setting.value : ""; // empty if subscription is not ready.                                        // 1557
  },                                                                                                                   // 1558
                                                                                                                       //
  getActivitySubscriptions: function getActivitySubscriptions(grainId, threadPath) {                                   // 1560
    return ActivitySubscriptions.find({                                                                                // 1561
      grainId: grainId,                                                                                                // 1562
      threadPath: threadPath || { $exists: false }                                                                     // 1563
    }, {                                                                                                               // 1561
      fields: { identityId: 1, mute: 1, _id: 0 }                                                                       // 1565
    }).fetch();                                                                                                        // 1564
  },                                                                                                                   // 1567
                                                                                                                       //
  subscribeToActivity: function subscribeToActivity(identityId, grainId, threadPath) {                                 // 1569
    // Subscribe the given identity to activity events with the given grainId and (optional)                           //
    // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                        //
    // case do nothing.                                                                                                //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1574
    if (threadPath) {                                                                                                  // 1575
      record.threadPath = threadPath;                                                                                  // 1576
    }                                                                                                                  // 1577
                                                                                                                       //
    // The $set here is redundant since an upsert automatically initializes a new record to contain                    //
    // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                      //
    // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                    //
    // What a wonderful query language.                                                                                //
    ActivitySubscriptions.upsert(record, { $set: record });                                                            // 1583
  },                                                                                                                   // 1584
                                                                                                                       //
  muteActivity: function muteActivity(identityId, grainId, threadPath) {                                               // 1586
    // Mute notifications for the given identity originating from the given grainId and                                //
    // (optional) threadPath.                                                                                          //
                                                                                                                       //
    var record = { identityId: identityId, grainId: grainId };                                                         // 1590
    if (threadPath) {                                                                                                  // 1591
      record.threadPath = threadPath;                                                                                  // 1592
    }                                                                                                                  // 1593
                                                                                                                       //
    ActivitySubscriptions.upsert(record, { $set: { mute: true } });                                                    // 1595
  },                                                                                                                   // 1596
                                                                                                                       //
  updateAppIndex: function updateAppIndex() {                                                                          // 1598
    var _this2 = this;                                                                                                 // 1598
                                                                                                                       //
    var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                    // 1599
    var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                                // 1600
    if (!appUpdatesEnabled) {                                                                                          // 1601
      // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                       //
      // timer that triggers this call.                                                                                //
      return;                                                                                                          // 1604
    }                                                                                                                  // 1605
                                                                                                                       //
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1607
    var appIndex = this.collections.appIndex;                                                                          // 1608
    var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                        // 1609
    var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                          // 1610
    // We make sure to get all preinstalled appIds, even ones that are currently                                       //
    // downloading/failed.                                                                                             //
    data.apps.forEach(function (app) {                                                                                 // 1613
      app._id = app.appId;                                                                                             // 1614
                                                                                                                       //
      var oldApp = appIndex.findOne({ _id: app.appId });                                                               // 1616
      app.hasSentNotifications = false;                                                                                // 1617
      appIndex.upsert({ _id: app._id }, app);                                                                          // 1618
      var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                               // 1619
      if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this2.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
        var pack = _this2.collections.packages.findOne({ _id: app.packageId });                                        // 1623
        var url = appIndexUrl + "/packages/" + app.packageId;                                                          // 1624
        if (pack) {                                                                                                    // 1625
          if (pack.status === "ready") {                                                                               // 1626
            if (pack.appId && pack.appId !== app.appId) {                                                              // 1627
              console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));        // 1628
            } else {                                                                                                   // 1630
              _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);   // 1631
            }                                                                                                          // 1633
          } else {                                                                                                     // 1634
            var result = Packages.findAndModify({                                                                      // 1635
              query: { _id: app.packageId },                                                                           // 1636
              update: { $set: { isAutoUpdated: true } }                                                                // 1637
            });                                                                                                        // 1635
                                                                                                                       //
            if (!result.ok) {                                                                                          // 1640
              return;                                                                                                  // 1641
            }                                                                                                          // 1642
                                                                                                                       //
            var newPack = result.value;                                                                                // 1644
            if (newPack.status === "ready") {                                                                          // 1645
              // The package was marked as ready before we applied isAutoUpdated=true. We should send                  //
              // notifications ourselves to be sure there's no timing issue (sending more than one is                  //
              // fine, since it will de-dupe).                                                                         //
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1649
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1650
              } else {                                                                                                 // 1652
                _this2.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
              }                                                                                                        // 1655
            } else if (newPack.status === "failed") {                                                                  // 1656
              // If the package has failed, retry it                                                                   //
              _this2.startInstall(app.packageId, url, true, true);                                                     // 1658
            }                                                                                                          // 1659
          }                                                                                                            // 1660
        } else {                                                                                                       // 1661
          _this2.startInstall(app.packageId, url, false, true);                                                        // 1662
        }                                                                                                              // 1663
      }                                                                                                                // 1664
    });                                                                                                                // 1665
  },                                                                                                                   // 1666
                                                                                                                       //
  isPackagePreinstalled: function isPackagePreinstalled(packageId) {                                                   // 1668
    return Settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;                     // 1669
  },                                                                                                                   // 1670
                                                                                                                       //
  getAppIdForPreinstalledPackage: function getAppIdForPreinstalledPackage(packageId) {                                 // 1672
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].appId;                                     // 1677
  },                                                                                                                   // 1678
                                                                                                                       //
  getPackageIdForPreinstalledApp: function getPackageIdForPreinstalledApp(appId) {                                     // 1680
    var setting = Settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });   // 1681
    // value.$ causes mongo to transform the result and only return the first matching element in                      //
    // the array                                                                                                       //
    return setting && setting.value && setting.value[0] && setting.value[0].packageId;                                 // 1685
  },                                                                                                                   // 1686
                                                                                                                       //
  getReadyPreinstalledAppIds: function getReadyPreinstalledAppIds() {                                                  // 1688
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1689
    var ret = setting && setting.value || [];                                                                          // 1690
    return _.chain(ret).filter(function (app) {                                                                        // 1691
      return app.status === "ready";                                                                                   // 1692
    }).map(function (app) {                                                                                            // 1692
      return app.appId;                                                                                                // 1693
    }).value();                                                                                                        // 1693
  },                                                                                                                   // 1695
                                                                                                                       //
  getAllPreinstalledAppIds: function getAllPreinstalledAppIds() {                                                      // 1697
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1698
    var ret = setting && setting.value || [];                                                                          // 1699
    return _.map(ret, function (app) {                                                                                 // 1700
      return app.appId;                                                                                                // 1700
    });                                                                                                                // 1700
  },                                                                                                                   // 1701
                                                                                                                       //
  preinstallAppsForUser: function preinstallAppsForUser(userId) {                                                      // 1703
    var _this3 = this;                                                                                                 // 1703
                                                                                                                       //
    var appIds = this.getReadyPreinstalledAppIds();                                                                    // 1704
    appIds.forEach(function (appId) {                                                                                  // 1705
      try {                                                                                                            // 1706
        _this3.addUserActions(userId, _this3.getPackageIdForPreinstalledApp(appId));                                   // 1707
      } catch (e) {                                                                                                    // 1708
        console.error("failed to install app for user:", e);                                                           // 1709
      }                                                                                                                // 1710
    });                                                                                                                // 1711
  },                                                                                                                   // 1712
                                                                                                                       //
  setPreinstallAppAsDownloading: function setPreinstallAppAsDownloading(appId, packageId) {                            // 1714
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
  },                                                                                                                   // 1718
                                                                                                                       //
  setPreinstallAppAsReady: function setPreinstallAppAsReady(appId, packageId) {                                        // 1720
    // This function both sets the appId as ready and updates the packageId for the given appId                        //
    // Setting the packageId is especially useful in installer.js, as it always ensures the                            //
    // latest installed package will be set as ready.                                                                  //
    this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
  },                                                                                                                   // 1727
                                                                                                                       //
  ensureAppPreinstall: function ensureAppPreinstall(appId, packageId) {                                                // 1729
    check(appId, String);                                                                                              // 1730
    var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                                 // 1731
    var pack = this.collections.packages.findOne({ _id: packageId });                                                  // 1732
    var url = appIndexUrl + "/packages/" + packageId;                                                                  // 1733
    if (pack && pack.status === "ready") {                                                                             // 1734
      this.setPreinstallAppAsReady(appId, packageId);                                                                  // 1735
    } else if (pack && pack.status === "failed") {                                                                     // 1736
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1737
      this.startInstall(packageId, url, true, false);                                                                  // 1738
    } else {                                                                                                           // 1739
      this.setPreinstallAppAsDownloading(appId, packageId);                                                            // 1740
      this.startInstall(packageId, url, false, false);                                                                 // 1741
    }                                                                                                                  // 1742
  },                                                                                                                   // 1743
                                                                                                                       //
  setPreinstalledApps: function setPreinstalledApps(appAndPackageIds) {                                                // 1745
    var _this4 = this;                                                                                                 // 1745
                                                                                                                       //
    // appAndPackageIds: A List[Object] where each element has fields:                                                 //
    //     appId: The Packages.appId of the app to install                                                             //
    //     packageId: The Packages._id of the app to install                                                           //
    check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                   // 1749
                                                                                                                       //
    // Start by clearing out the setting. We'll push appIds one by one to it                                           //
    this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                            // 1752
        value: appAndPackageIds.map(function (data) {                                                                  // 1753
          return {                                                                                                     // 1754
            appId: data.appId,                                                                                         // 1755
            status: "notReady",                                                                                        // 1756
            packageId: data.packageId                                                                                  // 1757
          };                                                                                                           // 1754
        })                                                                                                             // 1759
      } });                                                                                                            // 1752
    appAndPackageIds.forEach(function (data) {                                                                         // 1761
      _this4.ensureAppPreinstall(data.appId, data.packageId);                                                          // 1762
    });                                                                                                                // 1763
  },                                                                                                                   // 1764
                                                                                                                       //
  getProductivitySuiteAppIds: function getProductivitySuiteAppIds() {                                                  // 1766
    return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                          // 1767
    "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                                // 1769
    "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                             // 1770
    "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                           // 1771
  },                                                                                                                   // 1773
                                                                                                                       //
  // Wekan                                                                                                             //
  getSystemSuiteAppIds: function getSystemSuiteAppIds() {                                                              // 1775
    return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                   // 1776
  },                                                                                                                   // 1779
                                                                                                                       //
  // Collections                                                                                                       //
  isPreinstalledAppsReady: function isPreinstalledAppsReady() {                                                        // 1781
    var setting = Settings.findOne({ _id: "preinstalledApps" });                                                       // 1782
    if (!setting || !setting.value) {                                                                                  // 1783
      return true;                                                                                                     // 1784
    }                                                                                                                  // 1785
                                                                                                                       //
    var packageIds = _.pluck(setting.value, "packageId");                                                              // 1787
    var readyApps = this.collections.packages.find({                                                                   // 1788
      _id: {                                                                                                           // 1789
        $in: packageIds                                                                                                // 1790
      },                                                                                                               // 1789
      status: "ready"                                                                                                  // 1792
    });                                                                                                                // 1788
    return readyApps.count() === packageIds.length;                                                                    // 1794
  },                                                                                                                   // 1795
                                                                                                                       //
  getBillingPromptUrl: function getBillingPromptUrl() {                                                                // 1797
    var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                      // 1798
    return setting && setting.value;                                                                                   // 1799
  },                                                                                                                   // 1800
                                                                                                                       //
  isReferralEnabled: function isReferralEnabled() {                                                                    // 1802
    // This function is a bit weird, in that we've transitioned from                                                   //
    // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                    //
    // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                  //
    return Meteor.settings["public"].quotaEnabled;                                                                     // 1806
  },                                                                                                                   // 1807
                                                                                                                       //
  isQuotaEnabled: function isQuotaEnabled() {                                                                          // 1809
    if (Meteor.settings["public"].quotaEnabled) return true;                                                           // 1810
                                                                                                                       //
    var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                          // 1812
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1813
  },                                                                                                                   // 1814
                                                                                                                       //
  isQuotaLdapEnabled: function isQuotaLdapEnabled() {                                                                  // 1816
    var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                      // 1817
    return setting && setting.value && this.isFeatureKeyValid();                                                       // 1818
  },                                                                                                                   // 1819
                                                                                                                       //
  updateUserQuota: function updateUserQuota(user) {                                                                    // 1821
    if (this.quotaManager) {                                                                                           // 1822
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1823
    }                                                                                                                  // 1824
  },                                                                                                                   // 1825
                                                                                                                       //
  getUserQuota: function getUserQuota(user) {                                                                          // 1827
    if (this.isQuotaLdapEnabled()) {                                                                                   // 1828
      return this.quotaManager.updateUserQuota(this, user);                                                            // 1829
    } else {                                                                                                           // 1830
      var plan = Plans.findOne(user.plan || "free");                                                                   // 1831
      var referralBonus = calculateReferralBonus(user);                                                                // 1832
      var bonus = user.planBonus || {};                                                                                // 1833
      var userQuota = {                                                                                                // 1834
        storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                          // 1835
        grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                              // 1836
        compute: plan.compute + (bonus.compute || 0)                                                                   // 1837
      };                                                                                                               // 1834
      return userQuota;                                                                                                // 1839
    }                                                                                                                  // 1840
  },                                                                                                                   // 1841
                                                                                                                       //
  isUserOverQuota: function isUserOverQuota(user) {                                                                    // 1843
    // Return false if user has quota space remaining, true if it is full. When this returns true,                     //
    // we will not allow the user to create new grains, though they may be able to open existing ones                  //
    // which may still increase their storage usage.                                                                   //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1850
                                                                                                                       //
    var plan = this.getUserQuota(user);                                                                                // 1852
    if (plan.grains < Infinity) {                                                                                      // 1853
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();      // 1854
      if (count >= plan.grains) return "outOfGrains";                                                                  // 1856
    }                                                                                                                  // 1857
                                                                                                                       //
    return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                           // 1859
  },                                                                                                                   // 1860
                                                                                                                       //
  isUserExcessivelyOverQuota: function isUserExcessivelyOverQuota(user) {                                              // 1862
    // Return true if user is so far over quota that we should prevent their existing grains from                      //
    // running at all.                                                                                                 //
    //                                                                                                                 //
    // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                //
                                                                                                                       //
    if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                          // 1868
                                                                                                                       //
    var quota = this.getUserQuota(user);                                                                               // 1870
                                                                                                                       //
    // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                           //
    if (quota.grains < Infinity) {                                                                                     // 1873
      var count = this.collections.grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();
      if (count >= quota.grains * 2) return "outOfGrains";                                                             // 1876
    }                                                                                                                  // 1877
                                                                                                                       //
    return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                   // 1879
  }                                                                                                                    // 1880
});                                                                                                                    // 1137
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 1883
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   //
  // and seems to be a de facto standard, for example:                                                                 //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  //
  return key.replace(".", "．").replace("$", "＄");                                                                      // 1888
};                                                                                                                     // 1889
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 1891
  // This function takes a Package object from Mongo and returns an                                                    //
  // app title.                                                                                                        //
  var manifest = packageObj.manifest;                                                                                  // 1894
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 1895
  var action = manifest.actions[0];                                                                                    // 1896
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 1897
  return appName;                                                                                                      // 1899
};                                                                                                                     // 1900
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 1902
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  //
  //   derive the app title from the action title.                                                                     //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        //
  if (!name) {                                                                                                         // 1907
    return "(unnamed)";                                                                                                // 1908
  }                                                                                                                    // 1909
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 1911
    name = name.slice(4);                                                                                              // 1912
  }                                                                                                                    // 1913
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 1915
    name = "Hacker CMS";                                                                                               // 1916
  } else {                                                                                                             // 1917
    var space = name.indexOf(" ");                                                                                     // 1918
    if (space > 0) {                                                                                                   // 1919
      name = name.slice(0, space);                                                                                     // 1920
    }                                                                                                                  // 1921
  }                                                                                                                    // 1922
                                                                                                                       //
  return name;                                                                                                         // 1924
};                                                                                                                     // 1925
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 1927
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 1931
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 1933
  // A hack to deal with legacy apps not including fields in their manifests.                                          //
  // I look forward to the day I can remove most of this code.                                                         //
  // Attempt to figure out the appropriate noun that this action will create.                                          //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 1938
  // Otherwise, try to guess one from the structure of the action title field                                          //
  if (action.title && action.title.defaultText) {                                                                      // 1940
    var text = action.title.defaultText;                                                                               // 1941
    // Strip a leading "New "                                                                                          //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 1943
      var candidate = text.slice(4);                                                                                   // 1944
      // Strip a leading appname too, if provided                                                                      //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 1946
        var newCandidate = candidate.slice(appTitle.length);                                                           // 1947
        // Unless that leaves you with no noun, in which case, use "grain"                                             //
        if (newCandidate.length > 0) {                                                                                 // 1949
          return newCandidate.toLowerCase();                                                                           // 1950
        } else {                                                                                                       // 1951
          return "grain";                                                                                              // 1952
        }                                                                                                              // 1953
      }                                                                                                                // 1954
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 1956
    }                                                                                                                  // 1957
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        //
    // the package soon.                                                                                               //
    return text;                                                                                                       // 1960
  } else {                                                                                                             // 1961
    return "grain";                                                                                                    // 1962
  }                                                                                                                    // 1963
};                                                                                                                     // 1964
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          //
// Largely things that deal with backwards-compatibility.                                                              //
_.extend(SandstormDb, {                                                                                                // 1968
  appNameFromActionName: appNameFromActionName,                                                                        // 1969
  appNameFromPackage: appNameFromPackage,                                                                              // 1970
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 1971
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 1972
});                                                                                                                    // 1968
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1975
  (function () {                                                                                                       // 1975
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                           // 1975
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                      // 2200
    };                                                                                                                 // 2201
                                                                                                                       //
    // Cleanup tokens every hour.                                                                                      //
                                                                                                                       //
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1976
    var ContentType = Npm.require("content-type");                                                                     // 1977
    var Zlib = Npm.require("zlib");                                                                                    // 1978
    var Url = Npm.require("url");                                                                                      // 1979
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 1981
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 1983
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         //
      // The sequence looks like:                                                                                      //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             //
      //                                                                                                               //
      // We use this to determine how we'll stagger periodic events performed by this replica.                         //
      // Notice that this allows us to compute a stagger which is independent of the number of                         //
      // front-end replicas present; we can add more replicas to the end without affecting how the                     //
      // earlier ones schedule their events.                                                                           //
      var denom = 1;                                                                                                   // 1993
      while (denom <= n) {                                                                                             // 1994
        denom <<= 1;                                                                                                   // 1994
      }var num = n * 2 - denom + 1;                                                                                    // 1994
      return num / denom;                                                                                              // 1996
    };                                                                                                                 // 1997
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 1999
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2001
      // Register a database cleanup function than should run periodically, roughly once every                         //
      // interval of the given length.                                                                                 //
      //                                                                                                               //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      //
      // scaled appropriately on the assumption that more data is being generated demanding more                       //
      // frequent cleanups.                                                                                            //
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2009
      check(callback, Function);                                                                                       // 2010
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2012
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2013
      }                                                                                                                // 2015
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      //
      // the schedule is independent of the exact startup time.                                                        //
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2019
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       //
      // same data at the same time.                                                                                   //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2023
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           //
      if (first > intervalMs) first -= intervalMs;                                                                     // 2026
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2028
        callback();                                                                                                    // 2029
        Meteor.setInterval(callback, intervalMs);                                                                      // 2030
      }, first);                                                                                                       // 2031
    };                                                                                                                 // 2032
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2035
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2037
      return Match.Where(function (buf) {                                                                              // 2038
        check(buf, Buffer);                                                                                            // 2039
        return buf.length < limit;                                                                                     // 2040
      });                                                                                                              // 2041
    };                                                                                                                 // 2042
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2044
      check(s, String);                                                                                                // 2045
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2046
    });                                                                                                                // 2047
                                                                                                                       //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                      // 2049
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  //
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2053
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2054
        metadata.encoding = "gzip";                                                                                    // 2055
      }                                                                                                                // 2056
                                                                                                                       //
      check(metadata, {                                                                                                // 2058
        mimeType: String,                                                                                              // 2059
        encoding: Match.Optional("gzip")                                                                               // 2060
      });                                                                                                              // 2058
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2062
                                                                                                                       //
      // Validate content type.                                                                                        //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2065
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2067
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2068
      hasher.update(content);                                                                                          // 2069
      var hash = hasher.digest("base64");                                                                              // 2070
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2072
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2073
        update: { $inc: { refcount: 1 } },                                                                             // 2074
        fields: { _id: 1, refcount: 1 }                                                                                // 2075
      });                                                                                                              // 2072
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2078
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2079
      }                                                                                                                // 2080
                                                                                                                       //
      var existing = result.value;                                                                                     // 2082
      if (existing) {                                                                                                  // 2083
        return existing._id;                                                                                           // 2084
      }                                                                                                                // 2085
                                                                                                                       //
      return StaticAssets.insert(_.extend({                                                                            // 2087
        hash: hash,                                                                                                    // 2088
        content: content,                                                                                              // 2089
        refcount: 1                                                                                                    // 2090
      }, metadata));                                                                                                   // 2087
    };                                                                                                                 // 2092
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                             // 2094
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2096
      // Increment the refcount on an existing static asset. Returns the asset on success.                             //
      // If the asset does not exist, returns a falsey value.                                                          //
      //                                                                                                               //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2104
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2106
        query: { hash: hash },                                                                                         // 2107
        update: { $inc: { refcount: 1 } },                                                                             // 2108
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2109
      });                                                                                                              // 2106
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2112
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2113
      }                                                                                                                // 2114
                                                                                                                       //
      var existing = result.value;                                                                                     // 2116
      return existing;                                                                                                 // 2117
    };                                                                                                                 // 2118
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2120
      // Decrement refcount on a static asset and delete if it has reached zero.                                       //
      //                                                                                                               //
      // You must call this AFTER removing the reference from the DB, in case of failure between                       //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       //
                                                                                                                       //
      check(id, String);                                                                                               // 2127
                                                                                                                       //
      var result = StaticAssets.findAndModify({                                                                        // 2129
        query: { _id: id },                                                                                            // 2130
        update: { $inc: { refcount: -1 } },                                                                            // 2131
        fields: { _id: 1, refcount: 1 },                                                                               // 2132
        "new": true                                                                                                    // 2133
      });                                                                                                              // 2129
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2136
        throw new Error("Couldn't unref static asset " + id);                                                          // 2137
      }                                                                                                                // 2138
                                                                                                                       //
      var existing = result.value;                                                                                     // 2140
      if (!existing) {                                                                                                 // 2141
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2142
      } else if (existing.refcount <= 0) {                                                                             // 2143
        StaticAssets.remove({ _id: existing._id });                                                                    // 2144
      }                                                                                                                // 2145
    };                                                                                                                 // 2146
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2148
      // Get a static asset's mimeType, encoding, and raw content.                                                     //
                                                                                                                       //
      check(id, String);                                                                                               // 2151
                                                                                                                       //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });              // 2153
      if (asset) {                                                                                                     // 2154
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      //
        //   here.                                                                                                     //
        asset.content = new Buffer(asset.content);                                                                     // 2157
      }                                                                                                                // 2158
                                                                                                                       //
      return asset;                                                                                                    // 2160
    };                                                                                                                 // 2161
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2163
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return AssetUploadTokens.insert({                                                                                // 2169
        purpose: purpose,                                                                                              // 2170
        expires: new Date(Date.now() + 300000) });                                                                     // 2171
    };                                                                                                                 // 2173
                                                                                                                       //
    // in 5 minutes                                                                                                    //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2175
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       //
      // returned. If no matching upload exists, returns undefined.                                                    //
                                                                                                                       //
      check(id, String);                                                                                               // 2179
                                                                                                                       //
      var result = AssetUploadTokens.findAndModify({                                                                   // 2181
        query: { _id: id },                                                                                            // 2182
        remove: true                                                                                                   // 2183
      });                                                                                                              // 2181
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2186
        throw new Error("Failed to remove asset upload token");                                                        // 2187
      }                                                                                                                // 2188
                                                                                                                       //
      var upload = result.value;                                                                                       // 2190
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2192
        return undefined; // already expired                                                                           // 2193
      } else {                                                                                                         // 2194
          return upload.purpose;                                                                                       // 2195
        }                                                                                                              // 2196
    };                                                                                                                 // 2197
                                                                                                                       //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                  // 2204
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2206
      var _this5 = this;                                                                                               // 2206
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         //
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2209
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2211
      Grains.find(query).forEach(function (grain) {                                                                    // 2212
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2213
        numDeleted += Grains.remove({ _id: grain._id });                                                               // 2214
        _this5.removeApiTokens({                                                                                       // 2215
          grainId: grain._id,                                                                                          // 2216
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2217
        });                                                                                                            // 2215
                                                                                                                       //
        _this5.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2223
                                                                                                                       //
        ActivitySubscriptions.remove({ grainId: grain._id });                                                          // 2225
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2227
          DeleteStats.insert({                                                                                         // 2228
            type: "grain", // Demo grains can never get here!                                                          // 2229
            lastActive: grain.lastUsed,                                                                                // 2230
            appId: grain.appId                                                                                         // 2231
          });                                                                                                          // 2228
        }                                                                                                              // 2233
                                                                                                                       //
        _this5.deleteUnusedPackages(grain.appId);                                                                      // 2235
                                                                                                                       //
        if (grain.size) {                                                                                              // 2237
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2238
        }                                                                                                              // 2239
      });                                                                                                              // 2240
      return numDeleted;                                                                                               // 2241
    };                                                                                                                 // 2242
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2244
      check(grainId, String);                                                                                          // 2245
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2246
      check(identityId, String);                                                                                       // 2247
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2249
      if (!grain) {                                                                                                    // 2250
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2251
      }                                                                                                                // 2252
                                                                                                                       //
      var title = grain.title;                                                                                         // 2254
      if (grain.userId !== accountId) {                                                                                // 2255
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2256
          grainId: grainId,                                                                                            // 2257
          "owner.user.identityId": identityId                                                                          // 2258
        }, {                                                                                                           // 2256
          sort: {                                                                                                      // 2260
            lastUsed: -1                                                                                               // 2261
          }                                                                                                            // 2260
        });                                                                                                            // 2259
        if (sharerToken) {                                                                                             // 2264
          title = sharerToken.owner.user.title;                                                                        // 2265
        } else {                                                                                                       // 2266
          title = "shared grain";                                                                                      // 2267
        }                                                                                                              // 2268
      }                                                                                                                // 2269
                                                                                                                       //
      return title;                                                                                                    // 2271
    };                                                                                                                 // 2272
                                                                                                                       //
    var packageCache = {};                                                                                             // 2274
    // Package info is immutable. Let's cache to save on mongo queries.                                                //
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2277
      // Get the given package record. Since package info is immutable, cache the data in the server                   //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       //
      // lot.                                                                                                          //
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2282
        return packageCache[packageId];                                                                                // 2283
      }                                                                                                                // 2284
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 2286
      if (pkg && pkg.status === "ready") {                                                                             // 2287
        packageCache[packageId] = pkg;                                                                                 // 2288
      }                                                                                                                // 2289
                                                                                                                       //
      return pkg;                                                                                                      // 2291
    };                                                                                                                 // 2292
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2294
      check(appId, String);                                                                                            // 2295
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 2296
        // Mark package for possible deletion;                                                                         //
        Packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });                         // 2298
      });                                                                                                              // 2299
    };                                                                                                                 // 2300
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                                // 2304
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2307
        var userId = action.userId;                                                                                    // 2308
        var updater = {                                                                                                // 2309
          timestamp: new Date(),                                                                                       // 2310
          isUnread: true                                                                                               // 2311
        };                                                                                                             // 2309
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2313
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    //
        // field inside of an object to update                                                                         //
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2317
          marketingVersion: marketingVersion,                                                                          // 2318
          packageId: packageId,                                                                                        // 2319
          name: name,                                                                                                  // 2320
          version: versionNumber                                                                                       // 2321
        };                                                                                                             // 2317
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   //
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       //
        if (_this.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     //
          _this.collections.notifications.insert(inserter);                                                            // 2330
        }                                                                                                              // 2331
      });                                                                                                              // 2332
                                                                                                                       //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                     // 2334
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  //
      // package, we need to clean it up                                                                               //
      this.deleteUnusedPackages(appId);                                                                                // 2338
    };                                                                                                                 // 2339
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                           // 2341
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2343
      check(appId, String);                                                                                            // 2344
      check(version, Match.Integer);                                                                                   // 2345
      check(packageId, String);                                                                                        // 2346
                                                                                                                       //
      var selector = {                                                                                                 // 2348
        userId: Meteor.userId(),                                                                                       // 2349
        appId: appId,                                                                                                  // 2350
        appVersion: { $lte: version },                                                                                 // 2351
        packageId: { $ne: packageId }                                                                                  // 2352
      };                                                                                                               // 2348
                                                                                                                       //
      Grains.find(selector).forEach(function (grain) {                                                                 // 2355
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2356
      });                                                                                                              // 2357
                                                                                                                       //
      Grains.update(selector, {                                                                                        // 2359
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2360
      }, { multi: true });                                                                                             // 2359
    };                                                                                                                 // 2362
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2364
      // Mark package for possible installation.                                                                       //
                                                                                                                       //
      var fields = {                                                                                                   // 2367
        status: "download",                                                                                            // 2368
        progress: 0,                                                                                                   // 2369
        url: url,                                                                                                      // 2370
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2371
      };                                                                                                               // 2367
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2374
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                       // 2375
      } else {                                                                                                         // 2376
        try {                                                                                                          // 2377
          fields._id = packageId;                                                                                      // 2378
          Packages.insert(fields);                                                                                     // 2379
        } catch (err) {                                                                                                // 2380
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2381
        }                                                                                                              // 2382
      }                                                                                                                // 2383
    };                                                                                                                 // 2384
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2386
      check(keyFingerprint, String);                                                                                   // 2387
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2388
    });                                                                                                                // 2389
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2391
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   //
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2394
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2396
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2401
      }, function (err, keybaseResponse) {                                                                             // 2400
        if (err) {                                                                                                     // 2403
          console.log("keybase lookup error:", err.stack);                                                             // 2404
          return;                                                                                                      // 2405
        }                                                                                                              // 2406
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2408
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2409
          return;                                                                                                      // 2410
        }                                                                                                              // 2411
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2413
                                                                                                                       //
        if (profile) {                                                                                                 // 2415
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       //
          var record = {                                                                                               // 2417
            displayName: (profile.profile || {}).full_name,                                                            // 2418
            handle: (profile.basics || {}).username,                                                                   // 2419
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2420
          };                                                                                                           // 2417
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        //
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2424
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    //
            // this would filter.)                                                                                     //
            for (var field in proof) {                                                                                 // 2427
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        //
              // return any objects anyway).                                                                           //
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2431
                delete proof[field];                                                                                   // 2432
              }                                                                                                        // 2433
            }                                                                                                          // 2434
                                                                                                                       //
            // Indicate not verified.                                                                                  //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    //
            //   Keybase node-based CLI.                                                                               //
            proof.status = "unverified";                                                                               // 2439
          });                                                                                                          // 2440
                                                                                                                       //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                  // 2442
        } else {                                                                                                       // 2443
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    //
          // from Keybase.                                                                                             //
          //                                                                                                           //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     //
          //   but at present we don't have the ability to verify proofs.                                              //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2452
      });                                                                                                              // 2453
    };                                                                                                                 // 2454
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2456
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        //
                                                                                                                       //
      check(identityId, String);                                                                                       // 2459
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                        // 2460
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                     // 2469
        backend.deleteUser(account._id);                                                                               // 2470
      }                                                                                                                // 2471
    };                                                                                                                 // 2472
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2474
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2475
      var db = this.connection.sandstormDb;                                                                            // 2476
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2478
      if (cursor.count() === 0) {                                                                                      // 2479
        // Fire off async update.                                                                                      //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2481
      }                                                                                                                // 2482
                                                                                                                       //
      return cursor;                                                                                                   // 2484
    });                                                                                                                // 2485
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2487
      check(appId, String);                                                                                            // 2488
      var db = this.connection.sandstormDb;                                                                            // 2489
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2490
      return cursor;                                                                                                   // 2491
    });                                                                                                                // 2492
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2494
      var _this6 = this;                                                                                               // 2494
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         //
      // 1. referenced by one of their userActions                                                                     //
      // 2. referenced by one of their grains                                                                          //
      var db = this.connection.sandstormDb;                                                                            // 2498
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    //
      // to reactively remove a package from the client side when it is removed on the server, or                      //
      // when the client stops using it, because the worst case is the client has a small amount                       //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    //
      // stuff, we push the package info to the client, and then we never update it.                                   //
      //                                                                                                               //
      // Alternatively, we could subscribe to each individual package query, but this would waste                      //
      // lots of server-side resources watching for events that will never happen or don't matter.                     //
      var hasPackage = {};                                                                                             // 2510
      var refPackage = function refPackage(packageId) {                                                                // 2511
        // Ignore dev apps.                                                                                            //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2513
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2515
          hasPackage[packageId] = true;                                                                                // 2516
          var pkg = db.getPackage(packageId);                                                                          // 2517
          if (pkg) {                                                                                                   // 2518
            _this6.added("packages", packageId, pkg);                                                                  // 2519
          } else {                                                                                                     // 2520
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2521
          }                                                                                                            // 2523
        }                                                                                                              // 2524
      };                                                                                                               // 2525
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             //
      var actions = db.userActions(this.userId);                                                                       // 2528
      var actionsHandle = actions.observe({                                                                            // 2529
        added: function added(newAction) {                                                                             // 2530
          refPackage(newAction.packageId);                                                                             // 2531
        },                                                                                                             // 2532
                                                                                                                       //
        changed: function changed(newAction, oldAction) {                                                              // 2534
          refPackage(newAction.packageId);                                                                             // 2535
        }                                                                                                              // 2536
      });                                                                                                              // 2529
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     //
      var grains = db.userGrains(this.userId);                                                                         // 2540
      var grainsHandle = grains.observe({                                                                              // 2541
        added: function added(newGrain) {                                                                              // 2542
          refPackage(newGrain.packageId);                                                                              // 2543
        },                                                                                                             // 2544
                                                                                                                       //
        changed: function changed(newGrain, oldGrain) {                                                                // 2546
          refPackage(newGrain.packageId);                                                                              // 2547
        }                                                                                                              // 2548
      });                                                                                                              // 2541
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2551
        actionsHandle.stop();                                                                                          // 2552
        grainsHandle.stop();                                                                                           // 2553
      });                                                                                                              // 2554
                                                                                                                       //
      this.ready();                                                                                                    // 2556
    });                                                                                                                // 2557
  })();                                                                                                                // 1975
}                                                                                                                      // 2558
                                                                                                                       //
var processRawFeatureKey = function processRawFeatureKey(featureKey) {                                                 // 2560
  // Maps the raw data of a signed feature key to the desired "effective" feature key we should use                    //
  // to govern high-level behavior.                                                                                    //
  var processedFeatureKey = _.clone(featureKey);                                                                       // 2563
                                                                                                                       //
  // Hook for future extensibility.                                                                                    //
  return processedFeatureKey;                                                                                          // 2566
};                                                                                                                     // 2567
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2569
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2570
    // Returns an object with all of the current signed feature key properties,                                        //
    // or undefined, if the feature key is missing or not correctly signed.                                            //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                       // 2573
    if (!doc) return undefined;                                                                                        // 2574
    var buf = new Buffer(doc.value);                                                                                   // 2575
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                    //
    // once we can use ES6 modules.                                                                                    //
    var rawFeatureKey = loadSignedFeatureKey(buf);                                                                     // 2578
    return processRawFeatureKey(rawFeatureKey);                                                                        // 2579
  };                                                                                                                   // 2580
} else {                                                                                                               // 2581
  SandstormDb.prototype.currentFeatureKey = function () {                                                              // 2582
    var featureKey = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                // 2583
    return processRawFeatureKey(featureKey);                                                                           // 2584
  };                                                                                                                   // 2585
}                                                                                                                      // 2586
                                                                                                                       //
Meteor.methods({                                                                                                       // 2588
  addUserActions: function addUserActions(packageId) {                                                                 // 2589
    check(packageId, String);                                                                                          // 2590
    if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                       // 2591
      throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                         // 2592
    }                                                                                                                  // 2593
                                                                                                                       //
    if (this.isSimulation) {                                                                                           // 2595
      // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                      //
      //   a proper DB object to use.                                                                                  //
      new SandstormDb().addUserActions(this.userId, packageId, true);                                                  // 2598
    } else {                                                                                                           // 2599
      this.connection.sandstormDb.addUserActions(this.userId, packageId);                                              // 2600
    }                                                                                                                  // 2601
  },                                                                                                                   // 2602
  removeUserAction: function removeUserAction(actionId) {                                                              // 2604
    check(actionId, String);                                                                                           // 2605
    if (this.isSimulation) {                                                                                           // 2606
      UserActions.remove({ _id: actionId });                                                                           // 2607
    } else {                                                                                                           // 2608
      if (this.userId) {                                                                                               // 2609
        var result = UserActions.findAndModify({                                                                       // 2610
          query: { _id: actionId, userId: this.userId },                                                               // 2611
          remove: true                                                                                                 // 2612
        });                                                                                                            // 2610
                                                                                                                       //
        if (!result.ok) {                                                                                              // 2615
          throw new Error("Couldn't remove user action " + actionId);                                                  // 2616
        }                                                                                                              // 2617
                                                                                                                       //
        var action = result.value;                                                                                     // 2619
        if (action) {                                                                                                  // 2620
          this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                              // 2621
        }                                                                                                              // 2622
      }                                                                                                                // 2623
    }                                                                                                                  // 2624
  }                                                                                                                    // 2625
});                                                                                                                    // 2588
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       //
    // has a given identity linked. Automatically stops the subscription if the user loses the                         //
    // identity. Returns a boolean indicating whether the user initially has the identity.                             //
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function removed() {                                         // 47
            publishHandler.stop();                                                                                     // 47
          } });                                                                                                        // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                //
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 //
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      //
      // anyway to be safe.                                                                                            //
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     //
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              //
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         //
  // on the same account.                                                                                              //
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            //
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              //
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                            // 266
    if (email) {                                                                                                       // 267
      return [{ email: email, primary: true }];                                                                        // 268
    }                                                                                                                  // 269
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 270
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 271
  }                                                                                                                    // 272
                                                                                                                       //
  return [];                                                                                                           // 274
};                                                                                                                     // 275
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 277
  // Returns an array of identities which have the given email address as one of their verified                        //
  // addresses.                                                                                                        //
                                                                                                                       //
  check(email, String);                                                                                                // 281
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                    // 290
  });                                                                                                                  // 291
};                                                                                                                     // 292
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 294
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 295
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 300
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 302
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 303
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 304
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 308
  // Given an account user object, returns an array containing the ID of each identity linked to the                   //
  // account. Always returns the most recently added login identity first.                                             //
  if (user && user.loginIdentities) {                                                                                  // 311
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 312
  } else {                                                                                                             // 313
    return [];                                                                                                         // 314
  }                                                                                                                    // 315
};                                                                                                                     // 316
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 318
  // Given a user object, returns an array containing all email addresses associated with that user.                   //
  // Each entry in the array is an object of the form:                                                                 //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    //
  //                                                                                                                   //
  // At most one entry in the result has `primary = true`.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         //
  //   on SandstormDb.                                                                                                 //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 329
  var verifiedEmails = {};                                                                                             // 330
  var unverifiedEmails = {};                                                                                           // 331
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 333
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 334
    if (identity && identity.services) {                                                                               // 335
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 336
        if (verifiedEmail) {                                                                                           // 337
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 338
        }                                                                                                              // 339
      });                                                                                                              // 340
    }                                                                                                                  // 341
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 343
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 344
    }                                                                                                                  // 345
  });                                                                                                                  // 346
                                                                                                                       //
  var result = [];                                                                                                     // 348
  _.keys(verifiedEmails).map(function (email) {                                                                        // 349
    result.push({ email: email,                                                                                        // 350
      verified: true,                                                                                                  // 351
      primary: email === user.primaryEmail });                                                                         // 352
  });                                                                                                                  // 353
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 355
    if (!(email in verifiedEmails)) {                                                                                  // 356
      result.push({ email: email, verified: false });                                                                  // 356
    }                                                                                                                  // 356
  });                                                                                                                  // 357
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 360
    result[0].primary = true;                                                                                          // 361
  }                                                                                                                    // 362
                                                                                                                       //
  return result;                                                                                                       // 364
};                                                                                                                     // 365
                                                                                                                       //
SandstormDb.prototype.addContact = function addContact(ownerId, identityId) {                                          // 367
  check(ownerId, String);                                                                                              // 368
  check(identityId, String);                                                                                           // 369
  var profile = this.getIdentity(identityId).profile;                                                                  // 370
  this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                     // 371
    ownerId: ownerId,                                                                                                  // 372
    petname: profile && profile.name,                                                                                  // 373
    created: new Date(),                                                                                               // 374
    identityId: identityId                                                                                             // 375
  });                                                                                                                  // 371
};                                                                                                                     // 377
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
